Index: XIOS/trunk/src/type/type_impl.hpp
===================================================================
--- XIOS/trunk/src/type/type_impl.hpp	(revision 368)
+++ XIOS/trunk/src/type/type_impl.hpp	(revision 369)
@@ -7,5 +7,5 @@
 #include "buffer_out.hpp"
 #include "message.hpp"
-#include "type.hpp"
+
 
 
@@ -13,58 +13,150 @@
 namespace xios
 {
+ 
   using namespace std;
   
   template <typename T>
+  CType<T>::CType(void)
+  {
+    empty=true ;
+  }
+    
+  template <typename T>
   CType<T>::CType(const T& val)
   {
-    value=val ;
-    ptrValue=&value ;
-    clone=false ;
-  }
-  
-  template <typename T>
-  CType<T>::CType(T& val)
-  {
-    ptrValue=&val ;
-    clone=false ;
-  }
-
+    empty=true ;
+    set(val) ;
+  }
+  
   template <typename T>
   CType<T>::CType(const CType<T>& type)
   {
-    if (type.ptrValue==&type.value)
-    {
-       value=type.value ;
-       ptrValue=&value ;
-    }
-    else 
-    {
-      ptrValue=type.ptrValue ;
-    }
-  }
-  
-
-  
-  template <typename T>
-  void CType<T>::fromString(const string& str)
+    empty=true ;
+    set(type) ;
+  }
+
+  template <typename T>
+  CType<T>::CType(const CType_ref<T>& type)
+  {
+    empty=true ;
+    set(type) ;
+  }  
+  
+  template <typename T>
+  void CType<T>::set(const T& val)
+  {
+    if (empty) 
+    { 
+      ptrValue = new T(val) ;
+      empty=false ;
+    }
+    else *ptrValue = val ;
+  }
+
+  template <typename T>
+  void CType<T>::set(const CType<T>& type)
+  {
+    if (type.isEmpty()) reset() ;
+    else
+    {
+      if (empty)
+      { 
+        ptrValue = new T(*type.ptrValue) ;
+        empty=false ;
+      }
+      else *ptrValue = *type.ptrValue ;
+    }
+  }
+
+  template <typename T>
+  void CType<T>::set(const CType_ref<T>& type)
+  {
+    if (type.isEmpty()) reset() ;
+    else
+    {
+      if (empty)
+      { 
+        ptrValue = new T(*type.ptrValue) ;
+        empty=false ;
+      }
+      else *ptrValue = *type.ptrValue ;
+    }
+  }
+
+  template <typename T>
+  T& CType<T>::get(void)
+  {
+    checkEmpty();
+   return *ptrValue ;
+  }
+
+  template <typename T>
+  const T& CType<T>::get(void) const
+  {
+    checkEmpty();
+    return *ptrValue ;
+  }
+  
+  template <typename T>
+  CType<T>& CType<T>::operator = (const T& val)
+  {
+    set(val) ;
+    return *this ;
+  }
+  
+  template <typename T>
+  CType<T>& CType<T>::operator = (const CType<T>& type)
+  {
+    set(type) ;
+    return *this ;
+  }
+  
+  template <typename T>
+  CType<T>& CType<T>::operator = (const CType_ref<T>& type)
+  {
+    set(type) ;
+    return *this ;
+  }
+  
+   template <typename T>
+   CType<T>::operator T&()
+   {
+    checkEmpty();
+    return *ptrValue ;
+   }
+
+   template <typename T>
+   CType<T>* CType<T>::_clone(void) const
+   {
+     checkEmpty();
+     return new CType(*this) ;
+   }
+
+  
+  template <typename T>
+  void CType<T>::_fromString(const string& str)
   {
     istringstream iss(str);
-    checkAccess() ;
+    allocate() ;
     iss>>*ptrValue ;
-    
-  }
-
-  template <typename T>
-  size_t CType<T>::size(void) const
+  }
+
+  template <typename T>
+  size_t CType<T>::_size(void) const
   {
     return sizeof(T) ;
   }
   
-
-  template <typename T>
-  string CType<T>::toString(void) const
+  template <typename T>
+  bool CType<T>::_isEmpty(void) const
+  {
+    return empty ;
+  }
+  
+  template <typename T>
+  string CType<T>::_toString(void) const
   {
     ostringstream oss;
-    checkAccess() ;
+    checkEmpty();
     oss<<*ptrValue ;
     return oss.str() ;
@@ -72,39 +164,43 @@
   
   template <typename T>
-  bool CType<T>::toBuffer(CBufferOut& buffer) const
-  {
-    checkAccess() ;
+  bool CType<T>::_toBuffer(CBufferOut& buffer) const
+  {
+    checkEmpty();
     return buffer.put(*ptrValue) ;
   }
   
   template <typename T>
-  bool CType<T>::fromBuffer(CBufferIn& buffer)
-  {
-    checkAccess() ;
+  bool CType<T>::_fromBuffer(CBufferIn& buffer)
+  {
+    allocate() ;
     return buffer.get(*ptrValue) ;
   }
  
-     
-  template <typename T>
-  void CType<T>::checkAccess(void) const
-  {
-//    if (!isAssign) ERROR("void CType<T>::checkAccess",<<"CType<type> has not been assign to any buffer") ;
-  }
-
-  template <typename T>
-  CBaseType* CType<T>::duplicate(void) const
-  {
-    
-    CType<T>* ret= new CType<T>(*this) ;
-    ret->clone=true ;
-    return ret ;
-  }
-  
-  template <typename T>
-  void CType<T>::destroy(void)
-  {
-    if (clone) delete this ;
-  }
-  
+
+  template <typename T>
+  void CType<T>::allocate(void)
+  {
+    if (empty) 
+    {
+      ptrValue = new T ;
+      empty=false ;
+    }
+  }
+  
+  template <typename T>
+  void CType<T>::_reset(void)
+  {
+    if (!empty) 
+    {
+      delete ptrValue ;
+      empty=true ;
+    }
+  }
+  
+  template <typename T>
+  void CType<T>::checkEmpty(void) const
+  {
+    if (empty) ERROR("template <typename T> void CTypef<T>::checkEmpty(void) const", <<"Type is not initialized") ;
+  }  
 
   
@@ -117,11 +213,4 @@
   }
 
-  template <typename T>
-  CBufferOut& operator<<(CBufferOut& buffer, T& type)
-  {
-    if (!CType<T>(type).toBuffer(buffer)) ERROR("operator<<(CBuffer& buffer, T& type)",
-                                           <<"Buffer remain size is to low for size type") ;      
-    return buffer ;
-  }
 
   template <typename T>
@@ -134,49 +223,26 @@
   
   template <typename T>
-  CBufferIn& operator>>(CBufferIn& buffer, const CType<T>& type)
-  {
-    if (! const_cast<CType<T> & >(type).fromBuffer(buffer)) ERROR("CBuffer& operator<<(CBuffer& buffer, CType<T>& type)",
+  CBufferIn& operator>>(CBufferIn& buffer, CType<T>& type)
+  {
+    if (! type.fromBuffer(buffer)) ERROR("CBuffer& operator<<(CBuffer& buffer, CType<T>& type)",
                                            <<"Buffer remain size is to low for size type") ;
     return buffer ;
   }
   
-  template <typename T>
-  CBufferIn& operator>>(CBufferIn& buffer, T& type)
-  {
-    if (!CType<T>(type).fromBuffer(buffer)) ERROR(" CBuffer& operator>>(CBuffer& buffer, T& type)",
-                                           <<"Buffer remain size is to low for size type") ;
-    return buffer ;
-  }
-
-
-
+  
   template <typename T>
   CMessage& operator<<(CMessage& msg, const CType<T>& type)
   {
-    msg.push(*type.duplicate()) ;
+    msg.push(*type.clone()) ;
     return msg ;
   }
 
   template <typename T>
-  CMessage& operator<<(CMessage& msg,CType<T>& type)
-  {
-    msg.push(type) ;
+  CMessage& operator<<(CMessage& msg, const T& type)
+  {
+    msg.push(*CType<T>(type).clone()) ;
     return msg ;
   }
 
-  template <typename T>
-  CMessage& operator<<(CMessage& msg, const T& type)
-  {
-    msg.push(*CType<T>(type).duplicate()) ;
-    return msg ;
-  }
-  
-  template <typename T>
-  CMessage& operator<<(CMessage& msg, T& type)
-  {
-    msg.push(*CType<T>(type).duplicate()) ;
-    return msg ;
-  }
-
 }
 
Index: XIOS/trunk/src/type/type_ref_impl.hpp
===================================================================
--- XIOS/trunk/src/type/type_ref_impl.hpp	(revision 369)
+++ XIOS/trunk/src/type/type_ref_impl.hpp	(revision 369)
@@ -0,0 +1,256 @@
+
+#ifndef __XIOS_TYPE_REF_IMPL__
+#define __XIOS_TYPE_REF_IMPL__
+
+#include "xmlioserver_spl.hpp"
+#include "exception.hpp"
+#include "buffer_in.hpp"
+#include "buffer_out.hpp"
+#include "message.hpp"
+#include "type.hpp"
+
+
+
+namespace xios
+{
+    
+  using namespace std;
+  
+  template <typename T>
+  CType_ref<T>::CType_ref(void)
+  {
+    empty=true ;
+  }
+    
+  template <typename T>
+  CType_ref<T>::CType_ref(T& val)
+  {
+    empty=true ;
+    set_ref(val) ;
+  }
+  
+  template <typename T>
+  CType_ref<T>::CType_ref(CType<T>& type)
+  {
+    empty=true ;
+    set_ref(type) ;
+  }
+
+  template <typename T>
+  CType_ref<T>::CType_ref(const CType_ref<T>& type)
+  {
+    empty=true ;
+    set_ref(type) ;
+  }  
+
+  
+  template <typename T>
+  void CType_ref<T>::set_ref(T& val)
+  {
+    ptrValue=&val ;
+    empty=false ;
+  }
+
+  template <typename T>
+  void CType_ref<T>::set_ref(CType<T>& type)
+  {
+    ptrValue=&type.get() ;
+    empty=false ;
+  }
+
+  template <typename T>
+  void CType_ref<T>::set_ref(const CType_ref<T>& type)
+  {
+    ptrValue=type.ptrValue ;
+    empty=type.empty ;
+  }
+
+  template <typename T>
+  void CType_ref<T>::set(const T& val) const
+  {
+    checkEmpty() ;
+    *ptrValue=val ;
+  }
+
+  template <typename T>
+  void CType_ref<T>::set(const CType<T>& type) const
+  {
+    checkEmpty() ;
+    *ptrValue=type.get() ;
+  }
+
+  template <typename T>
+  void CType_ref<T>::set(const CType_ref<T>& type) const
+  {
+    checkEmpty() ;
+    *ptrValue=type.get() ;
+  }
+  
+  template <typename T>
+  T& CType_ref<T>::get(void) const
+  {
+    checkEmpty() ;
+    return *ptrValue ;
+  }
+  
+  template <typename T>
+  const CType_ref<T>& CType_ref<T>::operator = (T& val) const
+  {
+    set(val) ;
+    return *this ;
+  }
+
+  template <typename T>
+  const CType_ref<T>& CType_ref<T>::operator = (CType<T>& type) const
+  {
+    set(type) ;
+    return *this ;
+  }
+   
+  template <typename T>
+  const CType_ref<T>& CType_ref<T>::operator = (const CType_ref<T>& type) const
+  {
+    set(type) ;
+    return *this ;
+  }
+  
+  template <typename T>
+  CType_ref<T>::operator T&() const
+  {
+    checkEmpty() ;
+    return *ptrValue ;
+  }
+
+  template <typename T>
+  CType_ref<T>* CType_ref<T>::_clone(void) const
+  {
+    checkEmpty() ;
+    return new CType_ref<T>(*this) ;
+  }
+   
+  template <typename T>
+  void CType_ref<T>::_fromString(const string& str) const
+  {
+    istringstream iss(str);
+    checkEmpty() ;
+    iss>>*ptrValue ;
+  }
+ 
+  template <typename T>
+  void CType_ref<T>::_fromString(const string& str)
+  {
+    istringstream iss(str);
+    checkEmpty() ;
+    iss>>*ptrValue ;
+  }
+  
+  template <typename T>
+  string CType_ref<T>::_toString(void) const
+  {
+    ostringstream oss;
+    checkEmpty() ;
+    oss<<*ptrValue ;
+    return oss.str() ;
+  }
+
+    
+  template <typename T>
+  bool CType_ref<T>::_toBuffer(CBufferOut& buffer) const
+  {
+    checkEmpty() ;
+    return buffer.put(*ptrValue) ;
+  }
+  
+  template <typename T>
+  bool CType_ref<T>::_fromBuffer(CBufferIn& buffer)
+  {
+    checkEmpty() ;
+    return buffer.get(*ptrValue) ;
+  }
+ 
+  template <typename T>
+  bool CType_ref<T>::_fromBuffer(CBufferIn& buffer) const
+  {
+    checkEmpty() ;
+    return buffer.get(*ptrValue) ;
+  }
+ 
+  template <typename T>
+  size_t CType_ref<T>::_size(void) const
+  {
+    return sizeof(T) ;
+  }
+  
+  template <typename T>
+  bool CType_ref<T>::_isEmpty(void) const
+  {
+    return empty ;
+  }
+   
+  template <typename T>
+  void CType_ref<T>::_reset(void)
+  {
+      empty=true ;
+  }
+  
+  template <typename T>
+  void CType_ref<T>::checkEmpty(void) const
+  {
+    if (empty) ERROR("template <typename T> void CType_ref<T>::checkEmpty(void)",
+                     <<"Type_ref reference is not assigned") ;
+  }
+                     
+
+  
+  template <typename T>
+  CBufferOut& operator<<(CBufferOut& buffer, const CType_ref<T>& type)
+  {
+    if (!type.toBuffer(buffer)) ERROR("CBuffer& operator<<(CBuffer& buffer, CType<T>& type)",
+                                           <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferOut& operator<<(CBufferOut& buffer, T& type)
+  {
+    if (!CType_ref<T>(type).toBuffer(buffer)) ERROR("CBufferOut& operator<<(CBufferOut& buffer, T& type)",
+                                             <<"Buffer remain size is to low for size type") ;      
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, T& type)
+  {
+    if (! CType_ref<T>(type).fromBuffer(buffer)) ERROR(" template <typename T> CBufferIn& operator>>(CBufferIn& buffer, T& type)",
+                                                <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, const CType_ref<T>& type)
+  {
+    if (! type.fromBuffer(buffer) ) ERROR("CBuffer& operator<<(CBuffer& buffer, CType<T>& type)",
+                                           <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+
+
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, const CType_ref<T>& type)
+  {
+    msg.push(*type.clone()) ;
+    return msg ;
+  }
+
+
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, T& type)
+  {
+    msg.push(*CType_ref<T>(type).clone()) ;
+    return msg ;
+  }
+  
+}
+
+#endif
Index: XIOS/trunk/src/type/type_specialisation.hpp
===================================================================
--- XIOS/trunk/src/type/type_specialisation.hpp	(revision 368)
+++ XIOS/trunk/src/type/type_specialisation.hpp	(revision 369)
@@ -6,14 +6,53 @@
 #include "buffer_in.hpp"
 #include "buffer_out.hpp"
-#include "array.hpp"
-
+#include "type.hpp"
+#include <string>
+#include <boost/algorithm/string.hpp>
+ 
 namespace xios
 {
 
-
-// template specialisation for string
-
-  template <>
-  size_t CType<string>::size() const
+// template specialization for bool
+
+  template <> void CType<bool>::_fromString(const string& str)
+  {
+    string tmpStr=boost::to_lower_copy(boost::trim_copy(str)) ;
+    if (tmpStr=="true" || tmpStr==".true." || tmpStr=="yes" || tmpStr=="y") set(true) ;
+    else if (tmpStr=="false" || tmpStr==".false." || tmpStr=="no" || tmpStr=="n") set(false) ;
+    else ERROR("template <> CType<bool>::fromString(const string& str)",<< tmpStr << " cannot be converted in a boolean value") ;
+  }
+  
+  template <> string CType<bool>::_toString(void) const
+  {
+    if (get()) return string("true") ;
+    else return string("false") ;
+  }
+ 
+  template <> void CType_ref<bool>::_fromString(const string& str) const
+  {
+    string tmpStr=boost::to_lower_copy(boost::trim_copy(str)) ;
+    if (tmpStr=="true" || tmpStr==".true." || tmpStr=="yes" || tmpStr=="y") set(true) ;
+    else if (tmpStr=="false" || tmpStr==".false." || tmpStr=="no" || tmpStr=="n") set(false) ;
+    else ERROR("template <> CType<bool>::fromString(const string& str)",<< tmpStr << " cannot be converted in a boolean value") ;
+  }
+ 
+  template <> void CType_ref<bool>::_fromString(const string& str)
+  {
+    string tmpStr=boost::to_lower_copy(boost::trim_copy(str)) ;
+    if (tmpStr=="true" || tmpStr==".true." || tmpStr=="yes" || tmpStr=="y") set(true) ;
+    else if (tmpStr=="false" || tmpStr==".false." || tmpStr=="no" || tmpStr=="n") set(false) ;
+    else ERROR("template <> CType<bool>::fromString(const string& str)",<< tmpStr << " cannot be converted in a boolean value") ;
+  }
+  
+  template <> string CType_ref<bool>::_toString(void) const
+  {
+    if (get()) return string("true") ;
+    else return string("false") ;
+  }
+
+// template specialization for string
+
+  template <>
+  size_t CType<string>::_size() const
   {
     size_t typeSize=0 ;
@@ -22,7 +61,37 @@
     return typeSize ;
   }
-  
-  template <>
-  bool CType<string>::toBuffer(CBufferOut& buffer) const
+
+  template <>
+  size_t CType_ref<string>::_size() const
+  {
+    size_t typeSize=0 ;
+    typeSize+=sizeof(size_t) ;
+    typeSize+=ptrValue->size() ;
+    return typeSize ;
+  }
+  
+  template <>
+  void CType<string>::_fromString(const string& str)
+  {
+    allocate() ;
+    *ptrValue=str ;
+  }  
+
+  template <>
+  void CType_ref<string>::_fromString(const string& str)
+  {
+    checkEmpty() ;
+    *ptrValue=str ;
+  }  
+
+  template <>
+  void CType_ref<string>::_fromString(const string& str) const
+  {
+    checkEmpty() ;
+    *ptrValue=str ;
+  }  
+  
+  template <>
+  bool CType<string>::_toBuffer(CBufferOut& buffer) const
   {
     if (buffer.remain()<size()) return false ;
@@ -35,8 +104,24 @@
     }
   }
-
-  template <>
-  bool CType<string>::fromBuffer(CBufferIn& buffer)
-  {
+  
+  template <>
+  bool CType_ref<string>::_toBuffer(CBufferOut& buffer) const
+  {
+    if (buffer.remain()<size()) return false ;
+    else
+    {
+      bool ret=true ;
+      if (ret) ret&=buffer.put(ptrValue->size()) ;
+      if (ret) ret&=buffer.put(ptrValue->data(),ptrValue->size()) ;
+      return ret ;
+    }
+  }
+  
+  
+  
+  template <>
+  bool CType<string>::_fromBuffer(CBufferIn& buffer)
+  {
+    allocate() ;
     bool ret=true ;
     size_t typeSize ;
@@ -50,6 +135,34 @@
     return ret ;
   }  
-  
-  
+
+  template <>
+  bool CType_ref<string>::_fromBuffer(CBufferIn& buffer) const
+  {
+    bool ret=true ;
+    size_t typeSize ;
+    if (ret) ret&=buffer.get(typeSize) ;
+    
+    char* str;
+    str= (char*) buffer.ptr() ;
+    if (ret) buffer.advance(typeSize) ;
+    if (ret) *ptrValue=string(str,typeSize) ;
+    
+    return ret ;
+  }   
+
+  template <>
+  bool CType_ref<string>::_fromBuffer(CBufferIn& buffer)
+  {
+    bool ret=true ;
+    size_t typeSize ;
+    if (ret) ret&=buffer.get(typeSize) ;
+    
+    char* str;
+    str= (char*) buffer.ptr() ;
+    if (ret) buffer.advance(typeSize) ;
+    if (ret) *ptrValue=string(str,typeSize) ;
+    
+    return ret ;
+  }     
   // template specialisation for CArray
 /*
@@ -95,14 +208,28 @@
 boost::detail::multi_array::extent_gen<1> getExtentNull<1>(void) { return extents[0]; }
 */
-
+/*
 #define CTYPE_ARRAY(ValueType,NumsDims)                                \
+                                                                       \
+  template <>                                                          \
+  void CType<ARRAY(ValueType,NumsDims)>::allocate(void)  \
+  {                                                                    \
+    if (empty) ptrValue=new shared_ptr<CArray<ValueType, NumsDims> >(new  CArray<ValueType, NumsDims>()) ;\
+    empty=false ;                                                      \
+  }                                                                    \
+                                                                        \   
   template<>                                                           \
-  size_t CType< ARRAY(ValueType,NumsDims)>::size() const                           \
+  size_t CType< ARRAY(ValueType,NumsDims)>::_size() const               \
   {                                                                    \
      return (*(this->ptrValue))->getSize() ;                           \
   }                                                                    \
                                                                        \
-  template <>                                                          \
-  bool CType<ARRAY(ValueType,NumsDims)>::toBuffer(CBufferOut& buffer) const        \
+  template<>                                                           \
+  size_t CType_ref< ARRAY(ValueType,NumsDims)>::_size() const           \
+  {                                                                    \
+     return (*(this->ptrValue))->getSize() ;                           \
+  }                                                                    \
+                                                                       \
+  template <>                                                          \
+  bool CType<ARRAY(ValueType,NumsDims)>::_toBuffer(CBufferOut& buffer) const        \
   {                                                                    \
       return (*(this->ptrValue))->toBuffer(buffer) ;                   \
@@ -110,5 +237,25 @@
                                                                        \
   template <>                                                          \
-  bool CType<ARRAY(ValueType,NumsDims)>::fromBuffer(CBufferIn& buffer)       \
+  bool CType_ref<ARRAY(ValueType,NumsDims)>::_toBuffer(CBufferOut& buffer) const        \
+  {                                                                    \
+      return (*(this->ptrValue))->toBuffer(buffer) ;                   \
+  }                                                                    \
+                                                                       \
+  template <>                                                          \
+  bool CType<ARRAY(ValueType,NumsDims)>::_fromBuffer(CBufferIn& buffer)       \
+  {                                                                    \
+    allocate();                                                        \
+    return (*(ptrValue))->fromBuffer(buffer) ;                         \
+  }                                                                    \
+                                                                       \
+  template <>                                                          \
+  bool CType_ref<ARRAY(ValueType,NumsDims)>::_fromBuffer(CBufferIn& buffer) const  \
+  {                                                                    \
+    checkEmpty() ;                                                     \ 
+    return (*(this->ptrValue))->fromBuffer(buffer) ;                   \
+  }                                                                    \
+                                                                       \
+ template <>                                                          \
+  bool CType_ref<ARRAY(ValueType,NumsDims)>::_fromBuffer(CBufferIn& buffer)   \
   {                                                                    \
     shared_ptr<CArray<ValueType, NumsDims> > tmp(new CArray<ValueType, NumsDims>() ) ; \
@@ -117,17 +264,35 @@
   }                                                                    \
                                                                        \
-  template <>                                                          \
-  void CType<ARRAY(ValueType,NumsDims)>::fromString(const string& str)       \
-  {                                                                    \
- /* to implement */                                                    \
-  }                                                                    \
-                                                                       \
-  template <>                                                          \
-  string CType<ARRAY(ValueType,NumsDims)>::toString(void) const                    \
-  {                                                                    \
- /* to implement */                                                    \
+                                                                       \
+  template <>                                                          \
+  void CType<ARRAY(ValueType,NumsDims)>::_fromString(const string& str)       \
+  {                                                                    \
+                                      \
+  }                                                                    \
+                                                                       \
+  template <>                                                          \
+  void CType_ref<ARRAY(ValueType,NumsDims)>::_fromString(const string& str) const \
+  {                                                                    \
+                                        \
+  }                                                                    \
+  template <>                                                          \
+  void CType_ref<ARRAY(ValueType,NumsDims)>::_fromString(const string& str) \
+  {                                                                    \
+                                                \
+  }                                                                    \
+                                                                          \
+  template <>                                                          \
+  string CType<ARRAY(ValueType,NumsDims)>::_toString(void) const                    \
+  {                                                                    \
+                               \
    return string("") ;                                                 \
-  }
-
+  }                                                                    \
+                                                                          \
+  template <>                                                          \
+  string CType_ref<ARRAY(ValueType,NumsDims)>::_toString(void) const                    \
+  {                                                                    \
+                                      \
+   return string("") ;                                                 \
+  }
 //CTYPE_ARRAY(double,1) 
 
@@ -147,5 +312,5 @@
 CTYPE_ARRAY(float,2) 
 CTYPE_ARRAY(float,3) 
-
+*/
 }  
 
